; -----------------------------------------------------------------------------------
; RADIO FM AR1000                                                         
;
; STATUS: FUNCIONA
;
; Radio FM AR1000.
;
; Este e' um programa generico que apenas ativa o radio e permanece mudando as 
; estacoes.
;
; -----------------------------------------------------------------------------------
;
; HARDWARE:
; ----------------------------------------
; RC3 ......................... I2C SCL do AR1000
; RC4 ......................... I2C SDA do AR1000
; -----------------------------------------------------------------------------------
;
	LIST P=18F4520
	#include <P18F4520.INC>
    errorlevel -202          ; Inibe mensagem indesejada

;
; -----------------------------------------------------------------------------------
; CONFIGURATION BITS ou FUSES
; -----------------------------------------------------------------------------------
    CONFIG WDT    = OFF
	CONFIG MCLRE  = ON
	CONFIG DEBUG  = OFF
	CONFIG LVP    = OFF 
    CONFIG OSC    = HS

              #include "familias.inc"

; -----------------------------------------------------------------------------------
              UDATA   0x080

delay_temp    res       1
CLOCK         equ       .20000000

              #include "gpr.inc"

; ---------------------------------------------------------------------------------------
; Registradores e simbolos para o servico I2CMSSP_SERVICES
; ---------------------------------------------------------------------------------------
i2c_buff        RES      1
i2c_timeoutL    RES      1
i2c_timeoutH    RES      1

; ---------------------------------------------------------------------------------------
; Registradores e simbolos para o servico de controle do radio FM AR1000
; ---------------------------------------------------------------------------------------
I2C_CLOCK       equ   .20000000          ; 20MHZ - FOSC DO SISTEMA
I2C_FREQ        equ     .100000          ; SLEWRATE
AR1000PUT       equ        0x20          ; endereco write I2C do radio FM
AR1000GET       equ        0x21          ; endereco read I2C do radio FM 
ARFLAGS         RES          .1          ; Flags
ARSEEKDIR       equ          .0          ; direcao da pesquisa 0->Up  1-->Down
ARREGNUM        RES          .1
ARWRK01         RES          .1
ARNBYTES        RES          .1
ARFREQ          RES          .2          ; frequencia
ARREGS          RES         .36          ; buffer leitura/gravacao de registradores

;
; -----------------------------------------------------------------------------------
;
powr   CODE    0x000
       goto    inicio
intrf  CODE    0x008
       retfie
;
; -----------------------------------------------------------------------------------
;
MAIN   CODE
        #include "delay_services.inc"     ; Delays
        #include "i2cmssp_services.inc"   ; I2C MSSP Driver
        #include "ar1000_services.inc"    ; AR1010/AR1000 Driver
;
; -----------------------------------------------------------------------------------
;
inicio   movlw    0x0F
         movwf    ADCON1
         clrf     LATB
         clrf     TRISC
         clrf     TRISD
         call     ar1000Config                  ; configuracao inicial do AR1000  

loop     movlw    high(.319)                    ; Jovem Pan
         movwf    ARFREQ
         movlw    low(.319)
         movwf    ARFREQ+.1
         call     ar1000SetFreq

         movlw    .5
         call     tempo

         movlw    high(.279)                    ; Band News
         movwf    ARFREQ
         movlw    low(.279)
         movwf    ARFREQ+.1
         call     ar1000SetFreq

         movlw    .5
         call     tempo

         movlw    high(.343)                    ; Cultura FM
         movwf    ARFREQ
         movlw    low(.343)
         movwf    ARFREQ+.1
         call     ar1000SetFreq

         movlw    .5
         call     tempo


         movlw    .20
         movwf    R3
seekUp   movlw    .1
         call     ar1000Seek
         movlw    .4
         call     tempo
         decfsz   R3, f
         goto     seekUp

         movlw    .20
         movwf    R3
seekDw   movlw    .0
         call     ar1000Seek
         movlw    .4
         call     tempo
         decfsz   R3, f
         goto     seekDw




         goto     loop


tempo    movwf    R3
         rlcf     R3, f
         rlcf     R3, f
tx       movlw    .250
         call     delay_ms
         decfsz   R3, f
         goto     tx
         return



         END
